codeforces round 932 div2(a,b,c)

2024-04-05 21:52
文章标签 codeforces round div2 932

本文主要是介绍codeforces round 932 div2(a,b,c),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

d题容斥出的人比c反悔贪心还多…打完蓝桥再补补数论吧
比赛连接

A

题目大意

每次询问给定字符串 s s s n n n次操作, n n n为不小于 2 2 2的偶整数,每次操作可在以下两种任选其一

  • s s s反转之后的结果接入 s s s的后面
  • 反转 s s s

输出 n n n次操作后的最小字典序字符串

思路

注意 n n n是偶数且大于等于 2 2 2,所以我们只需要判断 s s s本身是否已经为最小字典序即可,若是,则可每次均反转,因为 n n n是正偶数,所以必然最后输出原字符串。若不是,则先反转再插入反转序列,继续反转再反转即可

ACcode

#include<bits/stdc++.h>using namespace std;#define int long longvoid solve()
{int n;cin >> n;string str;cin >> str;int be = 0;int en = str.size() - 1;int flag = 2;while (be < en) {if (str[be] > str[en]) {flag = 1;break;}if (str[be] < str[en]) {flag = 2;break;}be++;en--;}if (flag == 1) {reverse(str.begin(), str.end());cout << str;reverse(str.begin(), str.end());cout << str << '\n';}else if (flag == 2) {cout << str << '\n';}
}signed main()
{ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int t;cin >> t;while (t--) {solve();}return 0;
}

B

题目大意

给定长度 n n n的数组 a a a,请把 a a a分为 k k k段,每段 M E X MEX MEX值相同, k > 1 k>1 k>1 M E X MEX MEX值为不属于数组的最小非负整数

思路

注意到两个子段可以合成一个,所以只要能分成 k k k个,无论有多少个子段,都能最终合成为 2 2 2个。
所以我们从前后分别扫一遍,记录 M E X MEX MEX值,最后对比输出即可,若没有则输出-1

ACcode

#include<bits/stdc++.h>using namespace std;#define int long longvoid solve()
{int n;cin >> n;vector<int>a(n + 3);vector<int>pre(n + 3), nex(n + 3);map<int, int>b;int now = 0;for (int i = 1;i <= n;i++) {cin >> a[i], b[a[i]]++;while (b[now] > 0)now++;pre[i] = now;}b.clear(), now = 0;for (int i = n;i > 0;i--) {b[a[i]]++;while (b[now] > 0)now++;nex[i] = now;}for (int i = 1;i < n;i++) {if (pre[i] == nex[i + 1]) {cout << 2 << '\n';cout << 1 << ' ' << i << '\n';cout << i + 1 << ' ' << n << '\n';return;}}cout << -1 << '\n';
}signed main()
{ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int t;cin >> t;while (t--) {solve();}return 0;
}

C

题目大意

n n n条消息,每条由一个二元组 ( a , b ) (a,b) (a,b)描述,你需要找到最大的 k k k个并重新排序,使得这 k k k个的 a a a的和加上相邻 b b b的差的绝对值小于 l l l,输出 k k k

思路

用大顶堆实现反悔贪心
读题发现,排序只跟 b b b有关,所以先按 b b b由小到大排序
n n n个元素每个作为开始元素,遍历第 i + 1 i+1 i+1到第 n n n个,若满足 < = l <=l <=l,贪心的入堆
后面加判断,若当前元素 a a a小于堆顶且满足条件,扔掉堆顶,当前元素入堆,实现反悔

ACcode

#include<bits/stdc++.h>using namespace std;#define int long long
using PII = pair<int, int>;bool cmp(PII a, PII b) {return a.second < b.second;
}void solve()
{int n, l;cin >> n >> l;vector<PII>a(n);for (int i = 0;i < n;i++)cin >> a[i].first >> a[i].second;sort(a.begin(), a.end(), cmp);int ans = 0;for (int i = 0;i < n;i++) {priority_queue<int>q;if (a[i].first > l)continue;int sum = a[i].first;for (int j = i + 1;j < n;j++) {if (sum + a[j].first + a[j].second - a[i].second <= l) {sum += a[j].first;q.push(a[j].first);continue;}if (!q.empty()) {if (q.top() > a[j].first && sum - q.top() + a[j].first + a[j].second - a[i].second <= l) {sum -= q.top();q.pop();q.push(a[j].first);sum += a[j].first;}}}ans = max(ans, (int)q.size() + 1);}cout << ans << '\n';
}signed main()
{ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int t;cin >> t;while (t--) {solve();}return 0;
}

这篇关于codeforces round 932 div2(a,b,c)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/878237

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>

MemSQL Start[c]UP 2.0 - Round 1A(构造)

题目链接:http://codeforces.com/problemset/problem/452/A 解题思路: 打个表暴力查找匹配。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include <cstdio>#include <strin

Codeforces Round #281 (Div. 2)A(构造+暴力模拟)

题目链接:http://codeforces.com/problemset/problem/493/A 解题思路: 暴力的判断,分三种情况去判断即可。注意如果之前已经被罚下场后,那么在后面的罚下情况不应该算在输出结果内。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <co

Codeforces Round #182 (Div. 2)A(水题)

题目链接:http://codeforces.com/contest/302/problem/A 解题思路: 只要通过重新排列使区间内和为0即是1,否则是0. 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include <cstdio>#inc